package com.unimas.esql_api.v1;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;


import org.apache.http.Header;
import org.apache.http.HeaderElement;
import org.apache.http.HttpEntity;

import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;

import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.utils.URIBuilder;

import org.apache.http.entity.BasicHttpEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import com.google.gson.Gson;

public class ESql {

	private CloseableHttpClient httpclient;
	private String server;
	private Gson gson;
    private String cookie="";

	public ESql(String server_host, String username, String passwd) {
		httpclient = HttpClients.createDefault();
		server=server_host;
		gson = new Gson();
        login(username, passwd);
	}

    public ESql(String server_host) {
        httpclient = HttpClients.createDefault();
        server=server_host;
        gson = new Gson();
    }

    public class Result {
       public long count=0;
       public String msg;
       public String type;
       public int  took=0;
       public List<Map<String,String>> result;
    }

	public ESql.Result dosql(String sql) {
		ESql.Result result=new ESql.Result();
		try {
			URI uri = new URIBuilder()
			.setScheme("http")
			.setHost(server)
			.setPath("/json_out")
			.build();

            List <NameValuePair> params = new ArrayList<NameValuePair>();
            params.add(new BasicNameValuePair("sql", sql));
            HttpPost httpPost = new HttpPost(uri);
            httpPost.setEntity(new UrlEncodedFormEntity(params, HTTP.UTF_8));
            httpPost.addHeader("Cookie", cookie);
			CloseableHttpResponse response= httpclient.execute(httpPost);
			try{
			    HttpEntity entity = response.getEntity();
                if (entity != null) {
                    String entityStr = EntityUtils.toString(entity);
                    result =  gson.fromJson(entityStr, ESql.Result.class);
                }
			}finally{
				response.close();
			}
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (URISyntaxException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		return result ;
	}

    private void login(String username, String passwd) {
        String cookie = "";
        String session = "";
        try {
            URI uri = new URIBuilder()
                    .setScheme("http")
                    .setHost(server)
                    .setPath("/login")
                    .build();

            List <NameValuePair> params = new ArrayList<NameValuePair>();
            params.add(new BasicNameValuePair("username", username));
            params.add(new BasicNameValuePair("password", passwd));
            HttpPost httpPost = new HttpPost(uri);
            httpPost.setEntity(new UrlEncodedFormEntity(params, HTTP.UTF_8));
            CloseableHttpResponse response= httpclient.execute(httpPost);
            try{
                Header[] headers = response.getHeaders("Set-Cookie");
                for(Header header : headers) {
                    if(header!=null) {
                        HeaderElement[] headerElements = header.getElements();
                        if(headerElements!=null) {
                            for(HeaderElement headerElement : headerElements) {
                                if("session".equals(headerElement.getName()))
                                    session = headerElement.getValue();
                            }
                        }
                    }
                }
            }finally{
                response.close();
            }
        } catch (ClientProtocolException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (URISyntaxException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        cookie += "session="+session;
        this.cookie = cookie;
    }

    public static void main(String[] args) {
//        ESql esql = new ESql("10.68.23.85:8001","root","toor");
        ESql esql = new ESql("10.68.23.81:8001","root","toor");
        ESql.Result result = esql.dosql("select * from num_test");
        System.out.println(result.count+"  "+result.took +" " +result.msg);
        for (Map<String,String> a : result.result){
            for (Map.Entry<String,String> b:a.entrySet()){
                System.out.print(b.getKey() +":"+ b.getValue()+" ");
            }
            System.out.println("");
        }
    }
}
